Loading...
Searching...
No Matches
casacore::MEpoch Class Reference
measures package (libcasa_measures) » Measures_module

More...

`#include <MEpoch.h>`

## Public Types

enum | Types { LAST , LMST , GMST1 , GAST , UT1 , UT2 , UTC , TAI , TDT , TCG , TDB , TCB , N_Types , RAZE , EXTRA , IAT , GMST , TT , UT , ET , DEFAULT }
| Types of known MEpochs Caution: The order defines the order in the translation matrix in the MCEpoch class; Do not change the order without changing the array; Additions should be made before N_types, and an additional row and column should be coded in FromTo (MCEpoch), and in showType(); . More...
typedef MVEpoch | MVType
| Measure value container for this class (i.e.
typedef MCEpoch | MCType
| Measure conversion routines for this class (i.e.
typedef MeasRef< MEpoch > | Ref
| Measure reference (i.e.
typedef MeasConvert< MEpoch > | Convert
| Measure Convert (i.e.
typedef ScalarMeasColumn< MEpoch > | ScalarColumn
| Measure table Columns (e.g., MEpoch::ScalarColumn).
typedef ArrayMeasColumn< MEpoch > | ArrayColumn
Public Types inherited from casacore::Measure
enum | Types { N_Types , DEFAULT }
| Each derived class should have a Types enumeration, specifying the recognised frame types. More...
typedef void * | Convert
| Each Measure should have typedefs of the form:

## Public Member Functions

| MEpoch ()
| Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference; Default constructor; generates an instant at MJD 0 UTC
| MEpoch (const MVEpoch &dt)
| Create from data and reference.
| MEpoch (const MVEpoch &dt, const MEpoch::Ref &rf)
| MEpoch (const MVEpoch &dt, MEpoch::Types rf)
| MEpoch (const Quantity &dt)
| MEpoch (const Quantity &dt, const MEpoch::Ref &rf)
| MEpoch (const Quantity &dt, MEpoch::Types rf)
| MEpoch (const Measure *dt)
| MEpoch (const MeasValue *dt)
virtual | ~MEpoch ()
virtual const String & | tellMe () const
| Tell me your type.
Bool | giveMe (MEpoch::Ref &mr, const String &in)
virtual Bool | setOffset (const Measure &in)
| Set the offset in the reference (False if non-matching Measure).
virtual Bool | setRefString (const String &in)
| Set the reference type to the specified String.
virtual const String & | getDefaultType () const
| Get the default reference type.
virtual const String * | allTypes (Int &nall, Int &nextra, const uInt *&typ) const
| Get a list of all known reference codes.
virtual void | checkTypes () const
| Check if all internal tables of types (both enum and String) are complete and correct.
virtual String | getRefString () const
| Get the reference type (for records, including codes like R_).
Quantity | get (const Unit &inunit) const
| Get time in specified units.
virtual Measure * | clone () const
| Create copy.
Public Member Functions inherited from casacore::MeasBase< MVEpoch, MeasRef< MEpoch > >
| MeasBase ()
| Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference; For reasons of compiler limitations the formal arguments had to be specified as uInt rather than the Measure enums that should be used as actual arguments; Default constructor
MeasBase< MVEpoch, MeasRef< MEpoch > > & | operator= (const MeasBase< MVEpoch, MeasRef< MEpoch > > &other)
| Copy assignment.
virtual | ~MeasBase ()
virtual Bool | areYou (const String &tp) const
| Check the type of derived entity.
virtual void | assured (const String &tp) const
| Assert that we are the correct type.
void | set (const MVEpoch &dt)
| Refill the specified entities.
virtual Bool | putValue (const Vector< Quantum< Double > > &in)
MeasRef< MEpoch > | getRef () const
| Get reference.
const MVEpoch & | getValue () const
| Get Measure data.
const Unit & | getUnit () const
| Get Unit.
virtual MRBase * | getRefPtr () const
| Get reference pointer.
virtual const MeasValue * | getData () const
| Get pointer to data.
virtual void | print (std::ostream &os) const
| Print a Measure.
Public Member Functions inherited from casacore::Measure
virtual | ~Measure ()
| Destructor.
virtual void | set (const MeasValue &dt)=0
| Each Measure should have the following set functions (with appropiate MVs and Ref):
virtual Bool | isModel () const
| Tell me if you are a pure model (e.g.
void | dummy_giveMe () const
| Each derived class should have a string-to-code translation routine for the reference type.
void | dummy_getRef () const
| Each class should have a function to return its reference:
void | dummy_getValue () const
| Each derived class should be able to get its internal value and have:

## Static Public Member Functions

static const String & | showMe ()
static void | assure (const Measure &in)
static MEpoch::Types | castType (uInt tp)
| Translate reference code.
static const String & | showType (MEpoch::Types tp)
static const String & | showType (uInt tp)
static Bool | getType (MEpoch::Types &tp, const String &in)
| Translate string to reference code.
static const String * | allMyTypes (Int &nall, Int &nextra, const uInt *&typ)
static void | checkMyTypes ()
Static Public Member Functions inherited from casacore::Measure
static uInt | giveMe (const String &in, Int N_name, const String tname[])
| A general string checking routine to be used in derived measures.

## Friends

class | MeasConvert< MEpoch >

## Additional Inherited Members

Protected Attributes inherited from casacore::MeasBase< MVEpoch, MeasRef< MEpoch > >
MVEpoch | data
| The measure value (e.g.
MeasRef< MEpoch > | ref
| Reference frame data.
Unit | unit
| Possible input units.

## Detailed Description

A Measure: instant in time

### Intended use:

Public interface

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tMeasure

### Prerequisite

- Measure class

### Etymology

Measure and Epoch

### Synopsis

MEpoch forms derived Measure class for an instant in time.

### Example

Convert (with all steps explicit) a UTC to an IAT time.

#include <casacore/measures/Measures.h>
#include <casacore/measures/Measures/MEpoch.h>
#include <casacore/measures/Measures/MCEpoch.h>
#include <casacore/casa/logging/LogIO.h>
cout << "TAI for UTC = MJD(50237.29): " <<
MEpoch::Convert(MEpoch(MVEpoch(Quantity(50237.29, "d")),
MEpoch::Ref(MEpoch::UTC)),
MEpoch::Ref(MEpoch::TAI))() <<
endl;
LogIO os(LogOrigin("FluxCalc_SS_JPL_Butler", "readEphem"));
os << LogIO::DEBUG1 << " at ";
os.output() << MEpoch::Convert(MEpoch(MVEpoch(Quantity(50237.29, "d")),
MEpoch::Ref(MEpoch::UTC)),
MEpoch::Ref(MEpoch::TAI))();
os << LogIO::POST;
casacore::LogIO
Definition LogIO.h:165
casacore::LogIO::DEBUG1
@ DEBUG1
Change the message priority to DEBUGGING.
Definition LogIO.h:187
casacore::LogIO::POST
@ POST
Post the accumulated message.
Definition LogIO.h:170
casacore::LogOrigin
Definition LogOrigin.h:92
casacore::MEpoch::TAI
@ TAI
Definition MEpoch.h:126
casacore::MEpoch::UTC
@ UTC
Definition MEpoch.h:125
casacore::MEpoch::Ref
MeasRef< MEpoch > Ref
Measure reference (i.e.
Definition MEpoch.h:153
casacore::MEpoch::Convert
MeasConvert< MEpoch > Convert
Measure Convert (i.e.
Definition MEpoch.h:155
casacore::MEpoch::MEpoch
MEpoch()
Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measu...
casacore::MVEpoch
Definition MVEpoch.h:87
casacore::Quantity
Quantum< Double > Quantity
Definition Quantum.h:39

Results in:

TAI for UTC = MJD(50237.29): Epoch: 50237::06:58:06.0000 (on stdout)
at Epoch: 50237::06:58:06.0000 (in logger)

### Motivation

### To Do

Definition at line 101 of file MEpoch.h.

## Member Typedef Documentation

## ArrayColumn

typedef ArrayMeasColumn<MEpoch> casacore::MEpoch::ArrayColumn

Definition at line 158 of file MEpoch.h.

## Convert

typedef MeasConvert<MEpoch> casacore::MEpoch::Convert

Measure Convert (i.e.

MEpoch::Convert)

Definition at line 155 of file MEpoch.h.

## MCType

typedef MCEpoch casacore::MEpoch::MCType

Measure conversion routines for this class (i.e.

MEpoch::MCType)

Definition at line 151 of file MEpoch.h.

## MVType

typedef MVEpoch casacore::MEpoch::MVType

Measure value container for this class (i.e.

MEpoch::MVType)

Definition at line 149 of file MEpoch.h.

## Ref

typedef MeasRef<MEpoch> casacore::MEpoch::Ref

Measure reference (i.e.

MEpoch::Ref)

Definition at line 153 of file MEpoch.h.

## ScalarColumn

typedef ScalarMeasColumn<MEpoch> casacore::MEpoch::ScalarColumn

Measure table Columns (e.g., MEpoch::ScalarColumn).

Definition at line 157 of file MEpoch.h.

## Member Enumeration Documentation

## Types

enum casacore::MEpoch::Types

Types of known MEpochs
Caution: The order defines the order in the translation matrix in the MCEpoch class; Do not change the order without changing the array; Additions should be made before N_types, and an additional row and column should be coded in FromTo (MCEpoch), and in showType();
.

Enumerator
LAST | Local Apparent Sidereal Time.
LMST | Local Mean Sidereal Time.
GMST1 | Greenwich Mean ST1.
GAST | Greenwich Apparent ST.
UT1 |
UT2 |
UTC |
TAI |
TDT |
TCG |
TDB |
TCB |
N_Types | Number of types.
RAZE | Reduce result to integer days.
EXTRA | All extra bits.
IAT | Synonyms.
GMST |
TT |
UT |
ET |
DEFAULT | Default.

Definition at line 114 of file MEpoch.h.

## Constructor & Destructor Documentation

## MEpoch() [1/9]

casacore::MEpoch::MEpoch | ( |  | ) |

Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference;
Default constructor; generates an instant at MJD 0 UTC

Referenced by MeasConvert< MEpoch >.

## MEpoch() [2/9]

casacore::MEpoch::MEpoch | ( | const MVEpoch & | dt | ) |

Create from data and reference.

## MEpoch() [3/9]

casacore::MEpoch::MEpoch | ( | const MVEpoch & | dt,
|  | const MEpoch::Ref & | rf )

## MEpoch() [4/9]

casacore::MEpoch::MEpoch | ( | const MVEpoch & | dt,
|  | MEpoch::Types | rf )

## MEpoch() [5/9]

casacore::MEpoch::MEpoch | ( | const Quantity & | dt | ) |

## MEpoch() [6/9]

casacore::MEpoch::MEpoch | ( | const Quantity & | dt,
|  | const MEpoch::Ref & | rf )

## MEpoch() [7/9]

casacore::MEpoch::MEpoch | ( | const Quantity & | dt,
|  | MEpoch::Types | rf )

## MEpoch() [8/9]

casacore::MEpoch::MEpoch | ( | const Measure * | dt | ) |

## MEpoch() [9/9]

casacore::MEpoch::MEpoch | ( | const MeasValue * | dt | ) |

## ~MEpoch()

virtual casacore::MEpoch::~MEpoch | ( |  | ) |

virtual

## Member Function Documentation

## allMyTypes()

const String * casacore::MEpoch::allMyTypes | ( | Int & | nall,
|  | Int & | nextra,
|  | const uInt *& | typ )

static

## allTypes()

virtual const String * casacore::MEpoch::allTypes | ( | Int & | nall,
|  | Int & | nextra,
|  | const uInt *& | typ ) const

virtual

Get a list of all known reference codes.

nall returns the number in list, nextra the number of specials (like planets) that should be at end of list). typ returns the list of corresponding types.

Reimplemented from casacore::Measure.

## assure()

void casacore::MEpoch::assure | ( | const Measure & | in | ) |

static

## castType()

MEpoch::Types casacore::MEpoch::castType | ( | uInt | tp | ) |

static

Translate reference code.

The uInt version has a check for valid codes (i.e. it is a safe cast).

### Thrown Exceptions

- AipsError in the uInt interface if illegal code given

## checkMyTypes()

void casacore::MEpoch::checkMyTypes | ( |  | ) |

static

## checkTypes()

virtual void casacore::MEpoch::checkTypes | ( |  | ) | const

virtual

Check if all internal tables of types (both enum and String) are complete and correct.

This function is called automatically if and when necessary.

### Thrown Exceptions

- AipsError if a (programming) error in the types.

Implements casacore::Measure.

## clone()

virtual Measure * casacore::MEpoch::clone | ( |  | ) | const

virtual

Create copy.

Implements casacore::Measure.

## get()

Quantity casacore::MEpoch::get | ( | const Unit & | inunit | ) | const

Get time in specified units.

## getDefaultType()

virtual const String & casacore::MEpoch::getDefaultType | ( |  | ) | const

virtual

Get the default reference type.

Implements casacore::Measure.

## getRefString()

virtual String casacore::MEpoch::getRefString | ( |  | ) | const

virtual

Get the reference type (for records, including codes like R_).

Implements casacore::Measure.

## getType()

Bool casacore::MEpoch::getType | ( | MEpoch::Types & | tp,
|  | const String & | in )

static

Translate string to reference code.

## giveMe()

Bool casacore::MEpoch::giveMe | ( | MEpoch::Ref & | mr,
|  | const String & | in )

## setOffset()

virtual Bool casacore::MEpoch::setOffset | ( | const Measure & | in | ) |

virtual

Set the offset in the reference (False if non-matching Measure).

Implements casacore::Measure.

## setRefString()

virtual Bool casacore::MEpoch::setRefString | ( | const String & | in | ) |

virtual

Set the reference type to the specified String.

False if illegal string, reference set to DEFAULT.

Implements casacore::Measure.

## showMe()

const String & casacore::MEpoch::showMe | ( |  | ) |

static

## showType() [1/2]

const String & casacore::MEpoch::showType | ( | MEpoch::Types | tp | ) |

static

## showType() [2/2]

const String & casacore::MEpoch::showType | ( | uInt | tp | ) |

static

## tellMe()

virtual const String & casacore::MEpoch::tellMe | ( |  | ) | const

virtual

Tell me your type.

Implements casacore::Measure.

## Friends And Related Symbol Documentation

## MeasConvert< MEpoch >

friend class MeasConvert< MEpoch >

friend

Definition at line 1 of file MEpoch.h.

References MEpoch().

The documentation for this class was generated from the following file:

- measures/Measures/MEpoch.h